<?php

	function oliver_create_tabs($current = 'customizer')
	{
		$tabs = array(
			'customizer' => esc_html__('Customizer', 'oliver'),
			'sidebar'    => esc_html__('Sidebar', 'oliver'),
			'support'    => esc_html__('Support', 'oliver')
		);
		
		?>
			<h1><?php esc_html_e('Theme Options', 'oliver'); ?></h1>
			
			<h2 class="nav-tab-wrapper">
				<?php
					foreach ($tabs as $tab => $name)
					{
						$class = ($tab == $current) ? ' nav-tab-active' : "";
						
						echo "<a class='nav-tab$class' href='?page=oliver-theme-options&tab=$tab'>$name</a>";
					}
				?>
			</h2>
		<?php
	}


/* ============================================================================================================================================ */


	function oliver_theme_options_page()
	{
		global $pagenow;
		
		?>
			<div class="wrap wrap2">
				<div class="status">
					<img alt="..." src="<?php echo get_template_directory_uri(); ?>/admin/ajax-loader.gif">
					
					<strong></strong>
				</div>
				
				<?php
					if (isset($_GET['tab']))
					{
						oliver_create_tabs($_GET['tab']);
					}	
					else
					{
						oliver_create_tabs('customizer');
					}
				?>
				
				<div id="poststuff">
					<?php
						// Theme Options page.
						if ($pagenow == 'themes.php' && $_GET['page'] == 'oliver-theme-options')
						{
							// Tab from url.
							if ( isset( $_GET['tab'] ) )
							{
								$tab = $_GET['tab'];
							}
							else
							{
								$tab = 'customizer'; 
							}
							
							switch ($tab)
							{
								case 'customizer' :
									
									if (esc_attr( @$_GET['saved'] ) == 'true')
									{
										echo '<div class="alert-success" title="' . esc_html__('Click to close', 'oliver') . '"><p><strong>' . esc_html__('Saved.', 'oliver') . '</strong></p></div>';
									}
									
									?>
										<div class="postbox">
											<div class="inside">
												<?php
													$oliver_admin_url = admin_url( 'themes.php?page=oliver-theme-options' );
												?>
												<form method="post" class="ajax-form" action="<?php echo esc_url($oliver_admin_url); ?>">
													<?php
														wp_nonce_field("settings-page");
													?>
													<table>
														<tr>
															<td class="option-left">
																<?php
																	echo '<a class="button button-primary button-hero" href="' . esc_url(admin_url('customize.php')) . '">' . esc_html__('Customize Your Site', 'oliver') . '</a>';
																?>
															</td>
															<td class="option-right">
																<?php
																	esc_html_e('The Customizer allows you to preview changes to your site before publishing them.', 'oliver');
																?>
															</td>
														</tr>
													</table>
												</form>
											</div> <!-- .inside -->
										</div> <!-- .postbox -->
									<?php
								break;
								
								case 'sidebar' :
								
									if (esc_attr(@$_GET['saved']) == 'true')
									{
										$oliver_no_sidebar_name = get_option('oliver_no_sidebar_name');
										
										if ($oliver_no_sidebar_name == "")
										{
											echo '<div class="updated notice is-dismissible"><p>' . esc_html__('Enter text for a new sidebar name.', 'oliver') . '</p></div>';
										}
										else
										{
											echo '<div class="updated notice is-dismissible"><p>' . esc_html__('Sidebar created.', 'oliver') . '</p></div>';
										}
									}
									elseif (esc_attr(@$_GET['deleted']) == 'true')
									{
										delete_option('oliver_sidebars_with_commas');
										
										echo '<div class="updated notice is-dismissible"><p>' . esc_html__('Sidebars deleted.', 'oliver') . '</p></div>';
									}
									
									?>
										<div class="postbox">
											<div class="inside">
												<?php
													$oliver_admin_url = admin_url('themes.php?page=oliver-theme-options&tab=sidebar');
												?>
												<form method="post" action="<?php echo esc_url($oliver_admin_url); ?>">
													<?php
														wp_nonce_field( "settings-page" );
													?>
													<table>
														<tr>
															<td class="option-left">
																<h4><?php esc_html_e('New Sidebar', 'oliver'); ?></h4>
																<input type="text" name="oliver_new_sidebar_name" required="required" value="">
															</td>
															<td class="option-right">
																<?php
																	esc_html_e('Enter text for a new sidebar name.', 'oliver');
																?>
															</td>
														</tr>
														<tr>
															<td class="option-left">
																<input type="submit" name="submit" class="button button-primary button-large" value="<?php esc_html_e('Create', 'oliver'); ?>">
																<input type="hidden" name="settings-submit" value="Y">
															</td>
															<td class="option-right">
																<?php
																	esc_html_e('Create new sidebar.', 'oliver');
																?>
															</td>
														</tr>
														<tr>
															<td class="option-left">
																<h4><?php esc_html_e('Sidebars', 'oliver'); ?></h4>
																<select name="sidebars" size="10" disabled="disabled">
																	<?php
																		$oliver_sidebars_with_commas = get_option( 'oliver_sidebars_with_commas' );
																		
																		if ( $oliver_sidebars_with_commas != "" )
																		{
																			$sidebars = preg_split("/[\s]*[,][\s]*/", $oliver_sidebars_with_commas);

																			foreach ( $sidebars as $sidebar_name )
																			{
																				echo '<option>' . $sidebar_name . '</option>';
																			}
																		}
																	?>
																</select>
															</td>
															<td class="option-right">
																<?php
																	esc_html_e('New sidebar name must be different from created sidebar names.', 'oliver');
																?>
															</td>
														</tr>
														<tr>
															<td class="option-left">
																<?php
																	$oliver_admin_url = admin_url( 'themes.php?page=oliver-theme-options&tab=sidebar&deleted=true' );
																?>
																<a class="button button-large button-sidebar-delete" href="<?php echo esc_url($oliver_admin_url); ?>"><?php esc_html_e('Delete', 'oliver'); ?></a>
															</td>
															<td class="option-right">
																<?php
																	esc_html_e('Remove.', 'oliver');
																?>
															</td>
														</tr>
													</table>
												</form>
											</div> <!-- .inside -->
										</div> <!-- .postbox -->
									<?php
								break;
								
								case 'support' :
									
									if (esc_attr( @$_GET['saved'] ) == 'true')
									{
										echo '<div class="alert-success" title="' . esc_html__('Click to close', 'oliver') . '"><p><strong>' . esc_html__('Saved.', 'oliver') . '</strong></p></div>';
									}
									
									?>
										<div class="postbox">
											<div class="inside">
												<?php
													$oliver_admin_url = admin_url( 'themes.php?page=oliver-theme-options' );
												?>
												<form method="post" class="ajax-form" action="<?php echo esc_url($oliver_admin_url); ?>">
													<?php
														wp_nonce_field("settings-page");
													?>
													<table>
														<tr>
															<td class="option-left">
																<h4><?php esc_html_e('Need Help?', 'oliver'); ?></h4>
																<a class="button button-primary button-support-forum" target="_blank" href="http://www.pixelwars.org/forums/"><?php esc_html_e('View Support Forum', 'oliver'); ?></a>
															</td>
															<td class="option-right">
																<?php
																	esc_html_e('Got something to say?', 'oliver');
																?>
															</td>
														</tr>
														<tr>
															<td class="option-left">
																<h4><?php esc_html_e('Documentation', 'oliver'); ?></h4>
																<a class="button" target="_blank" href="https://themeforest.net/downloads"><?php esc_html_e('Get Documentation', 'oliver'); ?></a>
															</td>
															<td class="option-right">
																<?php
																	esc_html_e('Theme documentation is in the package. You can find it on ThemeForest in your downloads menu.', 'oliver');
																?>
															</td>
														</tr>
														<tr>
															<td class="option-left">
																<h4><?php esc_html_e('Rate Theme', 'oliver'); ?></h4>
																<a class="button" target="_blank" href="http://themeforest.net/user/pixelwars/portfolio"><?php esc_html_e('Rate on ThemeForest', 'oliver'); ?></a>
															</td>
															<td class="option-right">
																<?php
																	esc_html_e('If you liked the theme you can rate it on ThemeForest in your downloads menu.', 'oliver');
																?>
															</td>
														</tr>
														<tr>
															<td class="option-left">
																<h4><?php esc_html_e('Follow Us', 'oliver'); ?></h4>
																<a class="button" target="_blank" href="http://themeforest.net/user/pixelwars/follow"><?php esc_html_e('Follow us on ThemeForest', 'oliver'); ?></a>
																<br>
																<br>
																<a class="button" target="_blank" href="https://twitter.com/pixelwarsdesign"><?php esc_html_e('Follow us on Twitter', 'oliver'); ?></a>
																<br>
																<br>
																<a class="button" target="_blank" href="https://www.instagram.com/pixelwarsdesign/"><?php esc_html_e('Follow us on Instagram', 'oliver'); ?></a>
																<br>
																<br>
																<a class="button" target="_blank" href="https://www.facebook.com/pixelwarsdesign/"><?php esc_html_e('Follow us on Facebook', 'oliver'); ?></a>
																<br>
																<br>
																<a class="button" target="_blank" href="https://www.youtube.com/c/pixelwarsdesign"><?php esc_html_e('Follow us on YouTube', 'oliver'); ?></a>
															</td>
															<td class="option-right">
																<?php
																	esc_html_e("Follow us and don't miss new upcoming premium themes.", 'oliver');
																?>
															</td>
														</tr>
													</table>
												</form>
											</div> <!-- .inside -->
										</div> <!-- .postbox -->
									<?php
								break;
							}
						}
					?>
				</div> <!-- #poststuff -->
			</div> <!-- .wrap .wrap2 -->
		<?php
	}


/* ============================================================================================================================================ */


	function oliver_theme_save_settings()
	{
		global $pagenow;
		
		if ( $pagenow == 'themes.php' && $_GET['page'] == 'oliver-theme-options' )
		{
			if ( isset ( $_GET['tab'] ) )
			{
				$tab = $_GET['tab'];
			}
			else
			{
				$tab = 'customizer';
			}
			
			
			switch ( $tab )
			{
				case 'customizer' :
				
					// ...
				
				break;
				
				case 'sidebar' :
				
					update_option( 'oliver_no_sidebar_name', esc_attr( $_POST['oliver_new_sidebar_name'] ) );
					
					if ( esc_attr( $_POST['oliver_new_sidebar_name'] ) != "" )
					{
						$oliver_sidebars_with_commas = get_option( 'oliver_sidebars_with_commas', "" );
						
						if ( $oliver_sidebars_with_commas == "" )
						{
							update_option( 'oliver_sidebars_with_commas', esc_attr( $_POST['oliver_new_sidebar_name'] ) );
						}
						else
						{
							update_option( 'oliver_sidebars_with_commas', get_option( 'oliver_sidebars_with_commas' ) . ',' . esc_attr( $_POST['oliver_new_sidebar_name'] ) );
						}
					}
				
				break;
			}
		}
	}


/* ============================================================================================================================================ */


	function oliver_load_settings_page()
	{
		if ( isset( $_POST["settings-submit"] ) == 'Y' )
		{
			check_admin_referer( "settings-page" );
			oliver_theme_save_settings();
			$url_parameters = isset( $_GET['tab'] ) ? 'tab=' . $_GET['tab'] . '&saved=true' : 'saved=true';
			wp_redirect( admin_url( 'themes.php?page=oliver-theme-options&' . $url_parameters ) );
			exit;
		}
	}


/* ============================================================================================================================================ */


	function oliver_theme_menu()
	{
		$settings_page = add_theme_page('Theme Options',
										'Theme Options',
										'edit_theme_options',
										'oliver-theme-options',
										'oliver_theme_options_page' );
		
		add_action( "load-{$settings_page}", 'oliver_load_settings_page' );
	}
	
	add_action( 'admin_menu', 'oliver_theme_menu' );

?>