<?php

	class oliver_Widget_Social_Media_Icon extends WP_Widget
	{
		public function __construct()
		{
			parent::__construct('oliver_widget_social_media_icon',
								esc_html__('(Oliver) Social Media Icon', 'oliver'),
								array('description' => esc_html__('Social media icons.', 'oliver')));
		}
		
		public function form($instance)
		{
			if (isset($instance['title'])) { $title = $instance['title']; } else { $title = ""; }
			if (isset($instance['oliver_icon'])) { $oliver_icon = $instance['oliver_icon']; } else { $oliver_icon = ""; }
			if (isset($instance['oliver_url'])) { $oliver_url = $instance['oliver_url']; } else { $oliver_url = ""; }
			if (isset($instance['oliver_new_tab'])) { $oliver_new_tab = $instance['oliver_new_tab']; } else { $oliver_new_tab = ""; }
			
			?>
				<p>
					<label for="<?php echo $this->get_field_id('title'); ?>"><?php esc_html_e('Title', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo esc_attr($title); ?>">
				</p>
				<p>
					<label for="<?php echo $this->get_field_id('oliver_icon'); ?>"><?php esc_html_e('Icon', 'oliver'); ?></label>
					
					<select id="<?php echo $this->get_field_id('oliver_icon'); ?>" name="<?php echo $this->get_field_name('oliver_icon'); ?>">
						<option></option>
						<option <?php if ($oliver_icon == 'facebook') { echo 'selected="selected"'; } ?> value="facebook">Facebook</option>
						<option <?php if ($oliver_icon == 'twitter') { echo 'selected="selected"'; } ?> value="twitter">Twitter</option>
						<option <?php if ($oliver_icon == 'google-plus') { echo 'selected="selected"'; } ?> value="google-plus">Google+</option>
						<option <?php if ($oliver_icon == 'instagram') { echo 'selected="selected"'; } ?> value="instagram">Instagram</option>
						<option <?php if ($oliver_icon == 'linkedin') { echo 'selected="selected"'; } ?> value="linkedin">LinkedIn</option>
						<option <?php if ($oliver_icon == 'pinterest') { echo 'selected="selected"'; } ?> value="pinterest">Pinterest</option>
						<option <?php if ($oliver_icon == 'flickr') { echo 'selected="selected"'; } ?> value="flickr">Flickr</option>
						<option <?php if ($oliver_icon == 'fivehundredpx') { echo 'selected="selected"'; } ?> value="fivehundredpx">500px</option>
						<option <?php if ($oliver_icon == 'behance') { echo 'selected="selected"'; } ?> value="behance">Behance</option>
						<option <?php if ($oliver_icon == 'dribbble') { echo 'selected="selected"'; } ?> value="dribbble">Dribbble</option>
						<option <?php if ($oliver_icon == 'forrst') { echo 'selected="selected"'; } ?> value="forrst">Forrst</option>
						<option <?php if ($oliver_icon == 'skype') { echo 'selected="selected"'; } ?> value="skype">Skype</option>
						<option <?php if ($oliver_icon == 'youtube') { echo 'selected="selected"'; } ?> value="youtube">YouTube</option>
						<option <?php if ($oliver_icon == 'vimeo') { echo 'selected="selected"'; } ?> value="vimeo">Vimeo</option>
						<option <?php if ($oliver_icon == 'soundcloud') { echo 'selected="selected"'; } ?> value="soundcloud">SoundCloud</option>
						<option <?php if ($oliver_icon == 'lastfm') { echo 'selected="selected"'; } ?> value="lastfm">Last.fm</option>
						<option <?php if ($oliver_icon == 'wordpress') { echo 'selected="selected"'; } ?> value="wordpress">WordPress</option>
						<option <?php if ($oliver_icon == 'tumblr') { echo 'selected="selected"'; } ?> value="tumblr">Tumblr</option>
						<option <?php if ($oliver_icon == 'blogger') { echo 'selected="selected"'; } ?> value="blogger">Blogger</option>
						<option <?php if ($oliver_icon == 'delicious') { echo 'selected="selected"'; } ?> value="delicious">Delicious</option>
						<option <?php if ($oliver_icon == 'digg') { echo 'selected="selected"'; } ?> value="digg">Digg</option>
						<option <?php if ($oliver_icon == 'github') { echo 'selected="selected"'; } ?> value="github">GitHub</option>
						<option <?php if ($oliver_icon == 'stack-overflow') { echo 'selected="selected"'; } ?> value="stack-overflow">Stack Overflow</option>
						<option <?php if ($oliver_icon == 'foursquare') { echo 'selected="selected"'; } ?> value="foursquare">Foursquare</option>
						<option <?php if ($oliver_icon == 'xing') { echo 'selected="selected"'; } ?> value="xing">Xing</option>
						<option <?php if ($oliver_icon == 'weibo') { echo 'selected="selected"'; } ?> value="weibo">Weibo</option>
						<option <?php if ($oliver_icon == 'slideshare') { echo 'selected="selected"'; } ?> value="slideshare">SlideShare</option>
						<option <?php if ($oliver_icon == 'vkontakte') { echo 'selected="selected"'; } ?> value="vkontakte">VKontakte</option>
						<option <?php if ($oliver_icon == 'picasa') { echo 'selected="selected"'; } ?> value="picasa">Picasa</option>
						<option <?php if ($oliver_icon == 'friendfeed') { echo 'selected="selected"'; } ?> value="friendfeed">FriendFeed</option>
						<option <?php if ($oliver_icon == 'vine') { echo 'selected="selected"'; } ?> value="vine">Vine</option>
						<option <?php if ($oliver_icon == 'bloglovin') { echo 'selected="selected"'; } ?> value="bloglovin">Bloglovin</option>
						<option <?php if ($oliver_icon == 'rss') { echo 'selected="selected"'; } ?> value="rss">RSS</option>
					</select>
				</p>
				<p>
					<label for="<?php echo $this->get_field_id('oliver_url'); ?>"><?php esc_html_e('URL', 'oliver'); ?></label>
					
					<input type="text" id="<?php echo $this->get_field_id('oliver_url'); ?>" name="<?php echo $this->get_field_name('oliver_url'); ?>" value="<?php echo esc_url($oliver_url); ?>">
					
					<label for="<?php echo $this->get_field_id('oliver_new_tab'); ?>"><?php esc_html_e('New Tab', 'oliver'); ?></label>
					
					<select id="<?php echo $this->get_field_id('oliver_new_tab'); ?>" name="<?php echo $this->get_field_name('oliver_new_tab'); ?>">
						<option <?php if ($oliver_new_tab == 'yes') { echo 'selected="selected"'; } ?> value="yes"><?php esc_html_e('Yes', 'oliver'); ?></option>
						<option <?php if ($oliver_new_tab == 'no') { echo 'selected="selected"'; } ?> value="no"><?php esc_html_e('No', 'oliver'); ?></option>
					</select>
				</p>
				
				<hr>
			<?php
		}
		
		public function update($new_instance, $old_instance)
		{
			$instance = array();
			$instance['title']          = strip_tags($new_instance['title']);
			$instance['oliver_icon']    = strip_tags($new_instance['oliver_icon']);
			$instance['oliver_url']     = strip_tags($new_instance['oliver_url']);
			$instance['oliver_new_tab'] = strip_tags($new_instance['oliver_new_tab']);
			return $instance;
		}
		
		public function widget($args, $instance)
		{
			extract($args);
			$oliver_icon    = apply_filters('widget_icon', $instance['oliver_icon']);
			$oliver_url     = apply_filters('widget_url', $instance['oliver_url']);
			$oliver_new_tab = apply_filters('widget_new_tab', $instance['oliver_new_tab']);
			
			echo $before_widget;
			
				if ($oliver_new_tab != 'no')
				{
					$oliver_new_tab = 'target="_blank"';
				}
				else
				{
					$oliver_new_tab = "";
				}
				
				?>
					<a class="social-link <?php echo esc_attr($oliver_icon); ?>" <?php echo $oliver_new_tab; ?> href="<?php echo esc_url($oliver_url); ?>"></a>
				<?php
			
			echo $after_widget;
		}
	}
	
	add_action('widgets_init', function() { register_widget('oliver_Widget_Social_Media_Icon'); });


/* ============================================================================================================================================= */


	class oliver_Widget_Social_Media_Feed extends WP_Widget
	{
		public function __construct()
		{
			parent::__construct('oliver_widget_social_media_feed',
								esc_html__('(Oliver) Social Media Feed', 'oliver'),
								array('description' => esc_html__('Social media feed.', 'oliver')));
		}
		
		public function form($instance)
		{
			if (isset($instance['title'])) { $title = $instance['title']; } else { $title = ""; }
			if (isset($instance['oliver_network'])) { $oliver_network = $instance['oliver_network']; } else { $oliver_network = ""; }
			if (isset($instance['oliver_user'])) { $oliver_user = $instance['oliver_user']; } else { $oliver_user = ""; }
			if (isset($instance['oliver_number_of_items'])) { $oliver_number_of_items = $instance['oliver_number_of_items']; } else { $oliver_number_of_items = '6'; }
			
			?>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php esc_attr_e('Title', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" value="<?php echo esc_attr($title); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_user')); ?>"><?php esc_attr_e('User', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('oliver_user')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_user')); ?>" value="<?php echo esc_attr($oliver_user); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_network')); ?>"><?php esc_attr_e('Network', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_network')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_network')); ?>">
						<option></option>
						<option <?php if ($oliver_network == 'pinterest') { echo 'selected="selected"'; } ?> value="pinterest">Pinterest</option>
						<option <?php if ($oliver_network == 'flickr') { echo 'selected="selected"'; } ?> value="flickr">Flickr</option>
						<option <?php if ($oliver_network == 'picasa') { echo 'selected="selected"'; } ?> value="picasa">Picasa</option>
					</select>
					
					<label for="<?php echo esc_attr($this->get_field_id('oliver_number_of_items')); ?>"><?php esc_attr_e('Show Items', 'oliver'); ?></label>
					
					<input type="number" min="1" max="50" step="1" id="<?php echo esc_attr($this->get_field_id('oliver_number_of_items')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_number_of_items')); ?>" value="<?php echo esc_attr($oliver_number_of_items); ?>">
				</p>
				
				<hr>
			<?php
		}
		
		public function update($new_instance, $old_instance)
		{
			$instance = array();
			$instance['title']                      = strip_tags($new_instance['title']);
			$instance['oliver_network']         = strip_tags($new_instance['oliver_network']);
			$instance['oliver_user']            = strip_tags($new_instance['oliver_user']);
			$instance['oliver_number_of_items'] = strip_tags($new_instance['oliver_number_of_items']);
			return $instance;
		}
		
		public function widget($args, $instance)
		{
			extract($args);
			$title                      = apply_filters('widget_title', $instance['title']);
			$oliver_network         = apply_filters('oliver_network', $instance['oliver_network']);
			$oliver_user            = apply_filters('oliver_user', $instance['oliver_user']);
			$oliver_number_of_items = apply_filters('oliver_number_of_items', $instance['oliver_number_of_items']);
			
			echo $before_widget;
			
				if (! empty($title))
				{
					echo $before_title . $title . $after_title;
				}
				
				if ($oliver_network == 'flickr')
				{
					?>
						<div class="flickr-badges flickr-badges-s">
							<script src="http://www.flickr.com/badge_code_v2.gne?size=s&amp;count=<?php echo esc_attr($oliver_number_of_items); ?>&amp;display=random&amp;layout=x&amp;source=user&amp;user=<?php echo esc_attr($oliver_user); ?>"></script>
						</div>
					<?php
				}
				else
				{
					?>
						<div class="social-feed" data-social-network="<?php echo esc_attr($oliver_network); ?>" data-username="<?php echo esc_attr($oliver_user); ?>" data-limit="<?php echo esc_attr($oliver_number_of_items); ?>"></div>
					<?php
				}
			
			echo $after_widget;
		}
	}
	
	add_action('widgets_init', function() { register_widget('oliver_Widget_Social_Media_Feed'); });


/* ============================================================================================================================================= */


	class oliver_Widget_About_Me extends WP_Widget
	{
		public function __construct()
		{
			parent::__construct('oliver_widget_about_me',
								esc_html__( '(Oliver) About Me', 'oliver' ),
								array( 'description' => esc_html__( 'About me widget.', 'oliver' ) ) );
		}
		
		public function form( $instance )
		{
			if ( isset( $instance[ 'title' ] ) ) { $title = $instance[ 'title' ]; } else { $title = ""; }
			if ( isset( $instance[ 'oliver_image_url' ] ) ) { $oliver_image_url = $instance[ 'oliver_image_url' ]; } else { $oliver_image_url = ""; }
			if ( isset( $instance[ 'oliver_description' ] ) ) { $oliver_description = $instance[ 'oliver_description' ]; } else { $oliver_description = ""; }
			if ( isset( $instance[ 'oliver_more_link_url' ] ) ) { $oliver_more_link_url = $instance[ 'oliver_more_link_url' ]; } else { $oliver_more_link_url = ""; }
			if ( isset( $instance[ 'oliver_style' ] ) ) { $oliver_style = $instance[ 'oliver_style' ]; } else { $oliver_style = ""; }
			
			?>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php esc_html_e('Title', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" value="<?php echo esc_attr($title); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_image_url')); ?>"><?php esc_html_e('Image', 'oliver'); ?></label>
					
					<input type="hidden" id="<?php echo esc_attr($this->get_field_id('oliver_image_url')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_image_url')); ?>" value="<?php echo esc_attr($oliver_image_url); ?>">
					<input type="button" class="button button-browse" value="<?php esc_html_e('Browse', 'oliver'); ?>">
					<?php
						$image = wp_get_attachment_image_src($oliver_image_url, 'oliver_image_size_2');
					?>
					<img class="widget-image" alt="" src="<?php echo esc_url($image[0]); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_description')); ?>"><?php esc_html_e('Description', 'oliver'); ?></label>
					
					<textarea class="widefat" rows="5" cols="20" id="<?php echo esc_attr($this->get_field_id('oliver_description')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_description')); ?>"><?php echo esc_textarea($oliver_description); ?></textarea>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_more_link_url')); ?>"><?php esc_html_e('More Link URL', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('oliver_more_link_url')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_more_link_url')); ?>" value="<?php echo esc_attr($oliver_more_link_url); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_style')); ?>"><?php esc_html_e('Style', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_style')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_style')); ?>">
						<option <?php if ($oliver_style == 'is-about-me-widget-default') { echo 'selected="selected"'; } ?> value="is-about-me-widget-default"><?php esc_html_e('Default', 'oliver'); ?></option>
						<option <?php if ($oliver_style == 'is-about-me-widget-round') { echo 'selected="selected"'; } ?> value="is-about-me-widget-round"><?php esc_html_e('Rounded Image', 'oliver'); ?></option>
					</select>
				</p>
				
				<hr>
			<?php
		}
		
		public function update( $new_instance, $old_instance )
		{
			$instance = array();
			$instance['title'] = strip_tags( $new_instance['title'] );
			$instance['oliver_image_url'] = strip_tags( $new_instance['oliver_image_url'] );
			$instance['oliver_description'] = strip_tags( $new_instance['oliver_description'] );
			$instance['oliver_more_link_url'] = strip_tags( $new_instance['oliver_more_link_url'] );
			$instance['oliver_style'] = strip_tags( $new_instance['oliver_style'] );
			return $instance;
		}
		
		public function widget( $args, $instance )
		{
			extract( $args );
			$title                    = apply_filters( 'widget_title', $instance['title'] );
			$oliver_image_url     = apply_filters( 'oliver_image_url', $instance['oliver_image_url'] );
			$oliver_description   = apply_filters( 'oliver_description', $instance['oliver_description'] );
			$oliver_more_link_url = apply_filters( 'oliver_more_link_url', $instance['oliver_more_link_url'] );
			$oliver_style         = apply_filters( 'oliver_style', $instance['oliver_style'] );
			
			echo $before_widget;
			
				if (! empty($title))
				{
					echo $before_title . $title . $after_title;
				}
				
				?>
					<div class="about-me-wrap <?php echo esc_attr($oliver_style); ?>">
						<?php
							$image = wp_get_attachment_image_src($oliver_image_url, 'oliver_image_size_2');
						?>
						<img alt="<?php bloginfo('name'); ?>" src="<?php echo esc_url($image[0]); ?>">
						
						<?php
							echo esc_html($oliver_description);
						?>
						
						<?php
							if (! empty($oliver_more_link_url))
							{
								?>
									<a href="<?php echo esc_url($oliver_more_link_url); ?>"><?php esc_html_e('more', 'oliver'); ?></a>
								<?php
							}
						?>
					</div>
				<?php
			
			echo $after_widget;
		}
	}
	
	add_action('widgets_init', function() { register_widget('oliver_Widget_About_Me'); });


/* ============================================================================================================================================= */


	class oliver_Widget_Intro extends WP_Widget
	{
		public function __construct()
		{
			parent::__construct('oliver_widget_intro',
								esc_html__('(Oliver) Intro', 'oliver'),
								array('description' => esc_html__('Intro widget.', 'oliver')));
		}
		
		public function form($instance)
		{
			if (isset($instance['title'])) { $title = $instance['title']; } else { $title = ""; }
			if (isset($instance['oliver_image_url'])) { $oliver_image_url = $instance['oliver_image_url']; } else { $oliver_image_url = ""; }
			if (isset($instance['oliver_bg_image_url'])) { $oliver_bg_image_url = $instance['oliver_bg_image_url']; } else { $oliver_bg_image_url = ""; }
			if (isset($instance['oliver_bg_video_embed'])) { $oliver_bg_video_embed = $instance['oliver_bg_video_embed']; } else { $oliver_bg_video_embed = ""; }
			if (isset($instance['oliver_bg_video_self_hosted'])) { $oliver_bg_video_self_hosted = $instance['oliver_bg_video_self_hosted']; } else { $oliver_bg_video_self_hosted = ""; }
			if (isset($instance['oliver_bg_video_parallax'])) { $oliver_bg_video_parallax = $instance['oliver_bg_video_parallax']; } else { $oliver_bg_video_parallax = ""; }
			if (isset($instance['oliver_description'])) { $oliver_description = $instance['oliver_description']; } else { $oliver_description = ""; }
			if (isset($instance['oliver_button_text'])) { $oliver_button_text = $instance['oliver_button_text']; } else { $oliver_button_text = ""; }
			if (isset($instance['oliver_button_url'])) { $oliver_button_url = $instance['oliver_button_url']; } else { $oliver_button_url = ""; }
			if (isset($instance['oliver_new_tab'])) { $oliver_new_tab = $instance['oliver_new_tab']; } else { $oliver_new_tab = ""; }
			
			?>
				<p>
					<label for="<?php echo esc_attr( $this->get_field_id('title') ); ?>"><?php esc_html_e('Title', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" value="<?php echo esc_attr($title); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_image_url')); ?>"><?php esc_html_e('Image', 'oliver'); ?></label>
					
					<input type="hidden" id="<?php echo esc_attr($this->get_field_id('oliver_image_url')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_image_url')); ?>" value="<?php echo esc_attr($oliver_image_url); ?>">
					<input type="button" class="button button-browse" value="<?php esc_html_e('Browse', 'oliver'); ?>">
					<?php
						$image = wp_get_attachment_image_src($oliver_image_url, 'oliver_image_size_2');
					?>
					<img class="widget-image" alt="" src="<?php echo esc_url($image[0]); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_bg_image_url')); ?>"><?php esc_html_e('Background Image', 'oliver'); ?></label>
					
					<input type="hidden" id="<?php echo esc_attr($this->get_field_id('oliver_bg_image_url')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_bg_image_url')); ?>" value="<?php echo esc_attr($oliver_bg_image_url); ?>">
					<input type="button" class="button button-browse" value="<?php esc_html_e('Browse', 'oliver'); ?>">
					<?php
						$image = wp_get_attachment_image_src($oliver_bg_image_url, 'oliver_image_size_2');
					?>
					<img class="widget-image" alt="" src="<?php echo esc_url($image[0]); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_bg_video_embed')); ?>"><?php esc_html_e('Background Embed Video', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('oliver_bg_video_embed')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_bg_video_embed')); ?>" value="<?php echo esc_attr($oliver_bg_video_embed); ?>">
					<span class="widget-option-info"><?php esc_html_e('YouTube, Vimeo embed code.', 'oliver'); ?></span>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_bg_video_self_hosted')); ?>"><?php esc_html_e('Background Self-Hosted Video', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('oliver_bg_video_self_hosted')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_bg_video_self_hosted')); ?>" value="<?php echo esc_url($oliver_bg_video_self_hosted); ?>">
					<input type="button" class="button button-browse-video" value="<?php esc_html_e('Browse', 'oliver'); ?>">
					<span class="widget-option-info"><?php esc_html_e('MP4 video.', 'oliver'); ?></span>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_bg_video_parallax')); ?>"><?php esc_html_e('Background Parallax Video', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('oliver_bg_video_parallax')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_bg_video_parallax')); ?>" value="<?php echo esc_url($oliver_bg_video_parallax); ?>">
					<span class="widget-option-info"><?php esc_html_e('YouTube, Vimeo page url.', 'oliver'); ?></span>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_description')); ?>"><?php esc_html_e('Description', 'oliver'); ?></label>
					
					<textarea class="widefat" rows="5" cols="20" id="<?php echo esc_attr($this->get_field_id('oliver_description')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_description')); ?>"><?php echo esc_textarea($oliver_description); ?></textarea>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_button_text')); ?>"><?php esc_html_e('Button Text', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('oliver_button_text')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_button_text')); ?>" value="<?php echo esc_attr($oliver_button_text); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_button_url')); ?>"><?php esc_html_e('Button URL', 'oliver'); ?></label>
					
					<input type="text" id="<?php echo esc_attr($this->get_field_id('oliver_button_url')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_button_url')); ?>" value="<?php echo esc_attr($oliver_button_url); ?>">
					
					<label for="<?php echo esc_attr($this->get_field_id('oliver_new_tab')); ?>"><?php esc_html_e('New Tab', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_new_tab')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_new_tab')); ?>">
						<option <?php if ($oliver_new_tab == 'no') { echo 'selected="selected"'; } ?> value="no"><?php esc_html_e('No', 'oliver'); ?></option>
						<option <?php if ($oliver_new_tab == 'yes') { echo 'selected="selected"'; } ?> value="yes"><?php esc_html_e('Yes', 'oliver'); ?></option>
					</select>
				</p>
				
				<hr>
			<?php
		}
		
		public function update($new_instance, $old_instance)
		{
			$instance = array();
			$instance['title'] 					   	 = strip_tags($new_instance['title']);
			$instance['oliver_image_url'] 	   		 = strip_tags($new_instance['oliver_image_url']);
			$instance['oliver_bg_image_url']   		 = strip_tags($new_instance['oliver_bg_image_url']);
			$instance['oliver_bg_video_embed'] 		 = strip_tags($new_instance['oliver_bg_video_embed'], '<iframe>');
			$instance['oliver_bg_video_self_hosted'] = strip_tags($new_instance['oliver_bg_video_self_hosted']);
			$instance['oliver_bg_video_parallax'] 	 = strip_tags($new_instance['oliver_bg_video_parallax']);
			$instance['oliver_description']    		 = strip_tags($new_instance['oliver_description']);
			$instance['oliver_button_text']    		 = strip_tags($new_instance['oliver_button_text']);
			$instance['oliver_button_url']     		 = strip_tags($new_instance['oliver_button_url']);
			$instance['oliver_new_tab'] 	   		 = strip_tags($new_instance['oliver_new_tab']);
			return $instance;
		}
		
		public function widget($args, $instance)
		{
			extract($args);
			$title                     	 = apply_filters('widget_title', $instance['title']);
			$oliver_image_url      		 = apply_filters('oliver_image_url', $instance['oliver_image_url']);
			$oliver_bg_image_url   		 = apply_filters('oliver_bg_image_url', $instance['oliver_bg_image_url']);
			$oliver_bg_video_embed 		 = apply_filters('oliver_bg_video_embed', $instance['oliver_bg_video_embed']);
			$oliver_bg_video_self_hosted = apply_filters('oliver_bg_video_self_hosted', $instance['oliver_bg_video_self_hosted']);
			$oliver_bg_video_parallax 	 = apply_filters('oliver_bg_video_parallax', $instance['oliver_bg_video_parallax']);
			$oliver_description    		 = apply_filters('oliver_description', $instance['oliver_description']);
			$oliver_button_text    		 = apply_filters('oliver_button_text', $instance['oliver_button_text']);
			$oliver_button_url     		 = apply_filters('oliver_button_url', $instance['oliver_button_url']);
			$oliver_new_tab        		 = apply_filters('oliver_new_tab', $instance['oliver_new_tab']);
			
			echo $before_widget;
			
				if (! empty($title))
				{
					echo $before_title . $title . $after_title;
				}
				
				?>
					<?php
						$image_bg = wp_get_attachment_image_src($oliver_bg_image_url, 'oliver_image_size_7');
					?>
					<div class="intro" style="background-image: url(<?php echo esc_url($image_bg[0]); ?>);" data-parallax-video="<?php echo esc_url($oliver_bg_video_parallax); ?>">
						<?php
							if (! empty($oliver_bg_video_embed))
							{
								?>
									<div class="intro-vid">
										<?php
											echo $oliver_bg_video_embed; // An iframe.
										?>
									</div>
								<?php
							}
							elseif (! empty($oliver_bg_video_self_hosted))
							{
								?>
									<div class="intro-vid">
										<video autoplay loop>
											<source type="video/mp4" src="<?php echo esc_url($oliver_bg_video_self_hosted); ?>">
										</video>
									</div>
								<?php
							}
						?>
						<div class="intro-content">
							<?php
								$image = wp_get_attachment_image_src($oliver_image_url, 'oliver_image_size_3');
								
								if (! empty($image))
								{
									?>
										<img alt="<?php bloginfo('name'); ?>" src="<?php echo esc_url($image[0]); ?>">
									<?php
								}
							?>
							<div class="intro-text">
								<h1>
									<?php
										echo esc_html($oliver_description);
									?>
								</h1>
								<?php
									if (! empty($oliver_button_text))
									{
										?>
											<a class="button" <?php if ($oliver_new_tab == 'yes') { echo 'target="_blank"'; } ?> href="<?php echo esc_url($oliver_button_url); ?>">
												<?php
													echo esc_html($oliver_button_text);
												?>
											</a>
										<?php
									}
								?>
							</div> <!-- .intro-text -->
						</div> <!-- .intro-content -->
					</div> <!-- .intro -->
				<?php
			
			echo $after_widget;
		}
	}
	
	add_action('widgets_init', function() { register_widget('oliver_Widget_Intro'); });


/* ============================================================================================================================================= */


	class oliver_Widget_Link_Box extends WP_Widget
	{
		public function __construct()
		{
			parent::__construct('oliver_widget_link_box',
								esc_html__('(Oliver) Link Box', 'oliver'),
								array('description' => esc_html__('Link box widget.', 'oliver')));
		}
		
		public function form($instance)
		{
			if (isset($instance['title'])) { $title = $instance[ 'title' ]; } else { $title = ""; }
			if (isset($instance['oliver_widget_option_1'])) { $oliver_widget_option_1 = $instance[ 'oliver_widget_option_1' ]; } else { $oliver_widget_option_1 = ""; }
			if (isset($instance['oliver_widget_option_2'])) { $oliver_widget_option_2 = $instance[ 'oliver_widget_option_2' ]; } else { $oliver_widget_option_2 = 'no'; }
			if (isset($instance['oliver_widget_option_3'])) { $oliver_widget_option_3 = $instance[ 'oliver_widget_option_3' ]; } else { $oliver_widget_option_3 = ""; }
			if (isset($instance['oliver_widget_option_4'])) { $oliver_widget_option_4 = $instance[ 'oliver_widget_option_4' ]; } else { $oliver_widget_option_4 = ""; }
			if (isset($instance['oliver_widget_option_5'])) { $oliver_widget_option_5 = $instance[ 'oliver_widget_option_5' ]; } else { $oliver_widget_option_5 = ""; }
			
			?>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php esc_html_e('Title', 'oliver'); ?></label>
					
					<input type="text" class="widefat" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" value="<?php echo esc_attr($title); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_3')); ?>"><?php esc_html_e('Image', 'oliver'); ?></label>
					
					<input type="hidden" id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_3')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_3')); ?>" value="<?php echo esc_attr($oliver_widget_option_3); ?>">
					<input type="button" class="button button-browse" value="<?php esc_attr_e('Browse', 'oliver'); ?>">
					<?php
						$image = wp_get_attachment_image_src($oliver_widget_option_3, 'oliver_image_size_3');
					?>
					<img class="widget-image" alt="" src="<?php echo esc_url($image[0]); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_1')); ?>"><?php esc_html_e('Link URL', 'oliver'); ?></label>
					
					<input type="text" id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_1')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_1')); ?>" value="<?php echo esc_attr($oliver_widget_option_1); ?>">
					
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_2')); ?>"><?php esc_html_e('New Tab', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_2')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_2')); ?>">
						<option <?php if ($oliver_widget_option_2 == 'no') { echo 'selected="selected"'; } ?> value="no"><?php esc_html_e('No', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_2 == 'yes') { echo 'selected="selected"'; } ?> value="yes"><?php esc_html_e('Yes', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_4')); ?>"><?php esc_html_e('Width', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_4')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_4')); ?>">
						<option <?php if ($oliver_widget_option_4 == "") { echo 'selected="selected"'; } ?> value=""><?php esc_html_e('25%', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_4 == 'w-33') { echo 'selected="selected"'; } ?> value="w-33"><?php esc_html_e('33%', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_4 == 'w-50') { echo 'selected="selected"'; } ?> value="w-50"><?php esc_html_e('50%', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_4 == 'w-100') { echo 'selected="selected"'; } ?> value="w-100"><?php esc_html_e('100%', 'oliver'); ?></option>
					</select>
					
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_5')); ?>"><?php esc_html_e('Ratio', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_5')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_5')); ?>">
						<option <?php if ($oliver_widget_option_5 == "") { echo 'selected="selected"'; } ?> value=""><?php esc_html_e('Square', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_5 == 'ratio-2-1') { echo 'selected="selected"'; } ?> value="ratio-2-1"><?php esc_html_e('Tall', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_5 == 'ratio-16-9') { echo 'selected="selected"'; } ?> value="ratio-16-9"><?php esc_html_e('Wide', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_5 == 'ratio-21-9') { echo 'selected="selected"'; } ?> value="ratio-21-9"><?php esc_html_e('Extra Wide', 'oliver'); ?></option>
					</select>
				</p>
				
				<hr>
			<?php
		}
		
		public function update($new_instance, $old_instance)
		{
			$instance = array();
			$instance['title'] = strip_tags($new_instance['title']);
			$instance['oliver_widget_option_1'] = strip_tags($new_instance['oliver_widget_option_1']);
			$instance['oliver_widget_option_2'] = strip_tags($new_instance['oliver_widget_option_2']);
			$instance['oliver_widget_option_3'] = strip_tags($new_instance['oliver_widget_option_3']);
			$instance['oliver_widget_option_4'] = strip_tags($new_instance['oliver_widget_option_4']);
			$instance['oliver_widget_option_5'] = strip_tags($new_instance['oliver_widget_option_5']);
			return $instance;
		}
		
		public function widget($args, $instance)
		{
			extract($args);
			$title = apply_filters('widget_title', $instance['title']);
			$oliver_widget_option_1 = apply_filters('oliver_widget_option_1', $instance['oliver_widget_option_1']);
			$oliver_widget_option_2 = apply_filters('oliver_widget_option_2', $instance['oliver_widget_option_2']);
			$oliver_widget_option_3 = apply_filters('oliver_widget_option_3', $instance['oliver_widget_option_3']);
			$oliver_widget_option_4 = apply_filters('oliver_widget_option_4', $instance['oliver_widget_option_4']);
			$oliver_widget_option_5 = apply_filters('oliver_widget_option_5', $instance['oliver_widget_option_5']);
			
			echo $before_widget;
			
				$width = $oliver_widget_option_4;
				
				if (isset($_GET['link_box_width']))
				{
					$width = 'w-' . $_GET['link_box_width'];
				}
				
				$ratio = $oliver_widget_option_5;
				
				if (isset($_GET['link_box_ratio']))
				{
					$ratio = 'ratio-' . $_GET['link_box_ratio'];
				}
				
				?>
                    <div class="block link-box <?php echo esc_attr($width); ?> <?php echo esc_attr($ratio); ?>">
						<?php
							$image = wp_get_attachment_image_src($oliver_widget_option_3, 'oliver_image_size_3');
						?>
                        <div class="post-thumbnail" style="background-image: url(<?php echo esc_url($image[0]); ?>);">
                            <div class="post-wrap">
                                <header class="entry-header">
                                    <h2 class="entry-title">
										<a <?php if ($oliver_widget_option_2 == 'yes') { echo 'target="_blank"'; } ?> href="<?php echo esc_url($oliver_widget_option_1); ?>">
											<?php
												echo esc_html($title);
											?>
										</a>
									</h2>
                                </header>
                                <a class="block-link" <?php if ($oliver_widget_option_2 == 'yes') { echo 'target="_blank"'; } ?> href="<?php echo esc_url($oliver_widget_option_1); ?>">
									<?php
										echo esc_html($title);
									?>
								</a>
                            </div>
                        </div>
                    </div>
				<?php
			
			echo $after_widget;
		}
	}
	
	add_action('widgets_init', function() { register_widget('oliver_Widget_Link_Box'); });


/* ============================================================================================================================================= */


	class oliver_Widget_Main_Slider extends WP_Widget
	{
		public function __construct()
		{
			parent::__construct('oliver_widget_main_slider',
								esc_html__('(Oliver) Main Slider', 'oliver'),
								array('description' => esc_html__("Display your site's posts.", 'oliver')));
		}
		
		public function form($instance)
		{
			if (isset($instance['title'])) { $title = $instance[ 'title' ]; } else { $title = ""; }
			if (isset($instance['oliver_widget_option_1'])) { $oliver_widget_option_1 = $instance['oliver_widget_option_1']; } else { $oliver_widget_option_1 = 'sticky'; }
			if (isset($instance['oliver_widget_option_2'])) { $oliver_widget_option_2 = $instance['oliver_widget_option_2']; } else { $oliver_widget_option_2 = '5'; }
			if (isset($instance['oliver_widget_option_3'])) { $oliver_widget_option_3 = $instance['oliver_widget_option_3']; } else { $oliver_widget_option_3 = 'w-50'; }
			if (isset($instance['oliver_widget_option_4'])) { $oliver_widget_option_4 = $instance['oliver_widget_option_4']; } else { $oliver_widget_option_4 = ""; }
			if (isset($instance['oliver_widget_option_5'])) { $oliver_widget_option_5 = $instance['oliver_widget_option_5']; } else { $oliver_widget_option_5 = '1'; }
			if (isset($instance['oliver_widget_option_6'])) { $oliver_widget_option_6 = $instance['oliver_widget_option_6']; } else { $oliver_widget_option_6 = 'false'; }
			if (isset($instance['oliver_widget_option_7'])) { $oliver_widget_option_7 = $instance['oliver_widget_option_7']; } else { $oliver_widget_option_7 = 'true'; }
			if (isset($instance['oliver_widget_option_8'])) { $oliver_widget_option_8 = $instance['oliver_widget_option_8']; } else { $oliver_widget_option_8 = 'true'; }
			if (isset($instance['oliver_widget_option_9'])) { $oliver_widget_option_9 = $instance['oliver_widget_option_9']; } else { $oliver_widget_option_9 = 'false'; }
			if (isset($instance['oliver_widget_option_10'])) { $oliver_widget_option_10 = $instance['oliver_widget_option_10']; } else { $oliver_widget_option_10 = 'false'; }
			if (isset($instance['oliver_widget_option_11'])) { $oliver_widget_option_11 = $instance['oliver_widget_option_11']; } else { $oliver_widget_option_11 = '4000'; }
			
			?>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('title')); ?>"><?php esc_html_e('Title', 'oliver'); ?></label>
					
					<input type="text" id="<?php echo esc_attr($this->get_field_id('title')); ?>" name="<?php echo esc_attr($this->get_field_name('title')); ?>" value="<?php echo esc_attr($title); ?>">
					<span class="widget-option-info"><?php esc_html_e('Enter title.', 'oliver'); ?></span>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_1')); ?>"><?php esc_html_e('Slides', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_1')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_1')); ?>">
						<option <?php if ($oliver_widget_option_1 == 'sticky') { echo 'selected="selected"'; } ?> value="sticky"><?php esc_html_e('Sticky posts', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_1 == 'latest') { echo 'selected="selected"'; } ?> value="latest"><?php esc_html_e('Latest posts', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_2')); ?>"><?php esc_html_e('Slides Count', 'oliver'); ?></label>
					
					<input type="number" min="1" max="20" step="1" id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_2')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_2')); ?>" value="<?php echo esc_attr($oliver_widget_option_2); ?>">
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_5')); ?>"><?php esc_html_e('Show Items', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_5')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_5')); ?>">
						<option <?php if ($oliver_widget_option_5 == '1') { echo 'selected="selected"'; } ?> value="1"><?php esc_html_e('1', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_5 == '2') { echo 'selected="selected"'; } ?> value="2"><?php esc_html_e('2', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_5 == '3') { echo 'selected="selected"'; } ?> value="3"><?php esc_html_e('3', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_5 == '4') { echo 'selected="selected"'; } ?> value="4"><?php esc_html_e('4', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_5 == '5') { echo 'selected="selected"'; } ?> value="5"><?php esc_html_e('5', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_3')); ?>"><?php esc_html_e('Width', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_3')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_3')); ?>">
						<option <?php if ($oliver_widget_option_3 == 'w-50') { echo 'selected="selected"'; } ?> value="w-50"><?php esc_html_e('50%', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_3 == 'w-75') { echo 'selected="selected"'; } ?> value="w-75"><?php esc_html_e('75%', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_3 == "") { echo 'selected="selected"'; } ?> value=""><?php esc_html_e('100%', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_4')); ?>"><?php esc_html_e('Ratio', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_4')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_4')); ?>">
						<option <?php if ($oliver_widget_option_4 == "") { echo 'selected="selected"'; } ?> value=""><?php esc_html_e('Square', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_4 == 'ratio-16-9') { echo 'selected="selected"'; } ?> value="ratio-16-9"><?php esc_html_e('Wide', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_4 == 'ratio-21-9') { echo 'selected="selected"'; } ?> value="ratio-21-9"><?php esc_html_e('Extra Wide', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_4 == 'ratio-ultra-wide') { echo 'selected="selected"'; } ?> value="ratio-ultra-wide"><?php esc_html_e('Ultra Wide', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_6')); ?>"><?php esc_html_e('Animation', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_6')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_6')); ?>">
						<option <?php if ($oliver_widget_option_6 == 'false') { echo 'selected="selected"'; } ?> value="false"><?php esc_html_e('Slide', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_6 == 'fade') { echo 'selected="selected"'; } ?> value="fade"><?php esc_html_e('Fade', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_6 == 'backSlide') { echo 'selected="selected"'; } ?> value="backSlide"><?php esc_html_e('Back Slide', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_6 == 'goDown') { echo 'selected="selected"'; } ?> value="goDown"><?php esc_html_e('Go Down', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_6 == 'fadeUp') { echo 'selected="selected"'; } ?> value="fadeUp"><?php esc_html_e('Fade Zoom', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_9')); ?>"><?php esc_html_e('Mouse Drag', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_9')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_9')); ?>">
						<option <?php if ($oliver_widget_option_9 == 'false') { echo 'selected="selected"'; } ?> value="false"><?php esc_html_e('No', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_9 == 'true') { echo 'selected="selected"'; } ?> value="true"><?php esc_html_e('Yes', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_7')); ?>"><?php esc_html_e('Nav Arrows', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_7')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_7')); ?>">
						<option <?php if ($oliver_widget_option_7 == 'true') { echo 'selected="selected"'; } ?> value="true"><?php esc_html_e('Yes', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_7 == 'false') { echo 'selected="selected"'; } ?> value="false"><?php esc_html_e('No', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_8')); ?>"><?php esc_html_e('Nav Dots', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_8')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_8')); ?>">
						<option <?php if ($oliver_widget_option_8 == 'true') { echo 'selected="selected"'; } ?> value="true"><?php esc_html_e('Yes', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_8 == 'false') { echo 'selected="selected"'; } ?> value="false"><?php esc_html_e('No', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_10')); ?>"><?php esc_html_e('Autoplay', 'oliver'); ?></label>
					
					<select id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_10')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_10')); ?>">
						<option <?php if ($oliver_widget_option_10 == 'false') { echo 'selected="selected"'; } ?> value="false"><?php esc_html_e('No', 'oliver'); ?></option>
						<option <?php if ($oliver_widget_option_10 == 'true') { echo 'selected="selected"'; } ?> value="true"><?php esc_html_e('Yes', 'oliver'); ?></option>
					</select>
				</p>
				<p>
					<label for="<?php echo esc_attr($this->get_field_id('oliver_widget_option_11')); ?>"><?php esc_html_e('Autoplay Timeout', 'oliver'); ?></label>
					
					<input type="number" min="500" max="10000" step="250" id="<?php echo esc_attr($this->get_field_id('oliver_widget_option_11')); ?>" name="<?php echo esc_attr($this->get_field_name('oliver_widget_option_11')); ?>" value="<?php echo esc_attr($oliver_widget_option_11); ?>">
					<span style="font-size: 11px; color: #999999;"><?php esc_html_e('Default: 4000 ms', 'oliver'); ?></span>
				</p>
				
				<hr>
			<?php
		}
		
		public function update($new_instance, $old_instance)
		{
			$instance = array();
			$instance['title'] = strip_tags($new_instance['title']);
			$instance['oliver_widget_option_1'] = strip_tags($new_instance['oliver_widget_option_1']);
			$instance['oliver_widget_option_2'] = strip_tags($new_instance['oliver_widget_option_2']);
			$instance['oliver_widget_option_3'] = strip_tags($new_instance['oliver_widget_option_3']);
			$instance['oliver_widget_option_4'] = strip_tags($new_instance['oliver_widget_option_4']);
			$instance['oliver_widget_option_5'] = strip_tags($new_instance['oliver_widget_option_5']);
			$instance['oliver_widget_option_6'] = strip_tags($new_instance['oliver_widget_option_6']);
			$instance['oliver_widget_option_7'] = strip_tags($new_instance['oliver_widget_option_7']);
			$instance['oliver_widget_option_8'] = strip_tags($new_instance['oliver_widget_option_8']);
			$instance['oliver_widget_option_9'] = strip_tags($new_instance['oliver_widget_option_9']);
			$instance['oliver_widget_option_10'] = strip_tags($new_instance['oliver_widget_option_10']);
			$instance['oliver_widget_option_11'] = strip_tags($new_instance['oliver_widget_option_11']);
			return $instance;
		}
		
		public function widget($args, $instance)
		{
			extract($args);
			$oliver_widget_option_1 = apply_filters('oliver_widget_option_1', $instance['oliver_widget_option_1']);
			$oliver_widget_option_2 = apply_filters('oliver_widget_option_2', $instance['oliver_widget_option_2']);
			$oliver_widget_option_3 = apply_filters('oliver_widget_option_3', $instance['oliver_widget_option_3']);
			$oliver_widget_option_4 = apply_filters('oliver_widget_option_4', $instance['oliver_widget_option_4']);
			$oliver_widget_option_5 = apply_filters('oliver_widget_option_5', $instance['oliver_widget_option_5']);
			$oliver_widget_option_6 = apply_filters('oliver_widget_option_6', $instance['oliver_widget_option_6']);
			$oliver_widget_option_7 = apply_filters('oliver_widget_option_7', $instance['oliver_widget_option_7']);
			$oliver_widget_option_8 = apply_filters('oliver_widget_option_8', $instance['oliver_widget_option_8']);
			$oliver_widget_option_9 = apply_filters('oliver_widget_option_9', $instance['oliver_widget_option_9']);
			$oliver_widget_option_10 = apply_filters('oliver_widget_option_10', $instance['oliver_widget_option_10']);
			$oliver_widget_option_11 = apply_filters('oliver_widget_option_11', $instance['oliver_widget_option_11']);
			
			echo $before_widget;
			
				// *** start Main Slider ***
				
					$slides 		= $oliver_widget_option_1;
					$slides_count   = $oliver_widget_option_2;
					$excluded_posts = "";
					
					if ($slides != 'latest')
					{
						$slides = get_option('sticky_posts');
					}
					else
					{
						$slides = "";
						$excluded_posts = get_option('sticky_posts');
					}
					
					$query = new WP_Query(array('post_type'      => 'post',
												'post__in'       => $slides,
												'post__not_in'   => $excluded_posts,
												'posts_per_page' => $slides_count));
					
					if ($query->have_posts()) :
					
						$width = $oliver_widget_option_3;
						
						if (isset($_GET['main_slider_width']))
						{
							$width = 'w-' . $_GET['main_slider_width'];
						}
						
						$ratio = $oliver_widget_option_4;
						
						if (isset($_GET['main_slider_ratio']))
						{
							$ratio = 'ratio-' . $_GET['main_slider_ratio'];
						}
						
						$items 			  = $oliver_widget_option_5;
						$animation 		  = $oliver_widget_option_6;
						$nav_arrows 	  = $oliver_widget_option_7;
						$nav_dots 		  = $oliver_widget_option_8;
						$mouse_drag 	  = $oliver_widget_option_9;
						$autoplay 		  = $oliver_widget_option_10;
						$autoplay_timeout = $oliver_widget_option_11;
						
						?>
							<div class="block slider-box <?php echo esc_attr($width); ?> <?php echo esc_attr($ratio); ?>">
								<div class="post-slider owl-carousel" data-items="<?php echo esc_attr($items); ?>" data-animation="<?php echo esc_attr($animation); ?>" data-nav="<?php echo esc_attr($nav_arrows); ?>" data-dots="<?php echo esc_attr($nav_dots); ?>" data-mouse-drag="<?php echo esc_attr($mouse_drag); ?>" data-autoplay="<?php echo esc_attr($autoplay); ?>" data-autoplay-timeout="<?php echo esc_attr($autoplay_timeout); ?>">
									<?php
										function oliver_main_slider__featured_media($width)
										{
											$browser_address_url = stripcslashes(get_option(get_the_ID() . 'oliver_featured_video_url', ""));
											$browser_address_url = trim($browser_address_url); // Strip whitespace (or other characters) from the beginning and end of the string.
											
											if (! empty($browser_address_url))
											{
												echo 'data-parallax-video="' . esc_url($browser_address_url) . '"';
											}
											elseif (has_post_thumbnail())
											{
												$feat_img = "";
												$feat_area_width = get_theme_mod('oliver_setting_feat_area_width', 'is-featured-area-fixed');
												
												if ($feat_area_width == 'is-featured-area-fixed')
												{
													if (($width == 'w-50') || ($width == 'w-75'))
													{
														$feat_img = wp_get_attachment_image_src(get_post_thumbnail_id(), 'oliver_image_size_3');
													}
													else
													{
														$feat_img = wp_get_attachment_image_src(get_post_thumbnail_id(), 'oliver_image_size_1');
													}
												}
												else
												{
													if ($width == 'w-50')
													{
														$feat_img = wp_get_attachment_image_src(get_post_thumbnail_id(), 'oliver_image_size_1');
													}
													else
													{
														$feat_img = wp_get_attachment_image_src(get_post_thumbnail_id(), 'oliver_image_size_7');
													}
												}
												
												echo 'style="background-image: url(' . esc_url($feat_img[0]) . ');"';
											}
										}
									?>
									
									<?php
										while ($query->have_posts()) : $query->the_post();
										
											$main_slider_meta_style = get_theme_mod('oliver_setting_main_slider_meta_style', 'is-cat-link-borders-light is-cat-link-rounded');
											
											?>
												<div class="slider-post main-slider-post is-post-dark <?php echo esc_attr($main_slider_meta_style); ?>">
													<div class="post-thumbnail" <?php oliver_main_slider__featured_media($width); ?>>
														<div class="post-wrap">
															<header class="entry-header">
																<div class="entry-meta">
																	<span class="cat-links">
																		<?php
																			the_category(' ');
																		?>
																	</span>	
																</div> <!-- .entry-meta -->
																<h2 class="entry-title">
																	<a href="<?php the_permalink(); ?>">
																		<?php
																			the_title();
																		?>
																	</a>
																</h2>
																<a class="more-link" href="<?php the_permalink(); ?>">
																	<?php
																		esc_html_e('View Post', 'oliver');
																	?>
																</a>
															</header> <!-- .entry-header -->
														</div> <!-- .post-wrap -->
													</div> <!-- .post-thumbnail -->
												</div> <!-- .main-slider-post -->
											<?php
										endwhile;
									?>
								</div> <!-- .post-slider -->
							</div> <!-- .slider-box -->
						<?php
					endif;
					wp_reset_postdata();
				
				// *** end Main Slider ***
			
			echo $after_widget;
		}
	}
	
	add_action('widgets_init', function() { register_widget('oliver_Widget_Main_Slider'); });

?>